#!/bin/sh

echo "Do you want to revert to factory default settings (y/n)?"
read proceed

if [ $proceed != "y" ]; then
    echo "Keeping current settings ..."
    exit;
fi

cat /proc/flash_write_enable
mount -o remount,rw /mnt/flash

if [ -f /mnt/flash/exgine.fdcfg ]; then
    cp -f /mnt/flash/exgine.fdcfg /mnt/flash/exgine.cfg
    sync
else
    echo "ERROR: Could not find factory default settings for exgine.cfg. Aborting ..."
    exit;
fi

if [ -f /mnt/flash/e2x.fdcfg ]; then
    cp -f /mnt/flash/e2x.fdcfg /mnt/flash/e2x.cfg
    sync
else
    echo "ERROR: Could not find factory default settings for e2x.cfg. Aborting ..."
    exit;
fi

mount -o remount,ro /mnt/flash
cat /proc/flash_write_disable



echo "In order for this change to take effect, you need to perform a reboot."
echo "Do you want to reboot now (y/n)?"
read proceed
if [ $proceed != "y" ]; then
    echo "Please remember to reboot later ..."
    exit;
fi

reboot;

