#!/bin/sh
echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>FM Complex Scale Vector Upload</TITLE><BODY>";
cd /mnt/flash

errMsg="<BR>Please use your browser's <B>back</B> button to correct the error.<BR>";

#
# Read CGI data
#
read data_in

#
# Parse the input data
#
if [ "X$data_in" != "X" ]; then
	#
	# Input checking
	#
	#echo "Got $data_in"
	tftpIp=`echo $data_in | sed -n "s/.*\(tftpIp=\)\([^\&]*\).*/\2/p"`
	enableCsv=`echo $data_in | sed -n "s/.*\(enableCsv=\)\([^\&]*\).*/\2/p"`
	
    
    if [ "$enableCsv" = "1" ]; then
        cd /tmp/
        tftp -g -r exgine.csv $tftpIp
        if [ ! -e exgine.csv ]; then
  			echo "Error transferring complex scale vector configuration file (file not present)<BR>$errMsg";
			exit;
        fi
        if [ ! -s exgine.csv ]; then
  			echo "Error transferring complex scale vector configuration file (empty file)<BR>$errMsg";
			exit;
        fi
    fi

    # enable write access
    cat /proc/flash_write_enable > /dev/null
    mount -o remount,rw /mnt/flash


    # delete the old file first
    rm -f /mnt/flash/exgine.csv > /dev/null

    if [ "$enableCsv" = "1" ]; then
        cp -f /tmp/exgine.csv /mnt/flash
    fi
    
    sync

    # disable write access 
    mount -o remount,ro /mnt/flash
    cat /proc/flash_write_disable > /dev/null

  	echo "<P><B>Note:</B> Complex scale vector has been applied successfully.  A <A HREF="reboot.sh">reboot</A> is required for these changes to take effect.<P>";

fi 

#
# Read configuration file settings
#


#
# Build the HTML page
#
echo "<FORM METHOD=POST ACTION=csvupload.sh>"

echo "<TABLE WIDTH=80% CELLSPACING=0 CELLPADDING=4>"
echo "<TR><TD bgcolor=\"#09254a\"><FONT color=gray FACE=\"Verdana\"><B>FM Compex Scale Vector Upload</B></FONT></TD>";
echo "<TD ALIGN=right bgcolor=\"#09254a\"><A HREF=\"/csv_hlp.html\" TRAGET=_blank><FONT color=gray FACE=\"Verdana\"><B>[help]</B></FONT></A></TD></TR>";
echo "<TR><TD><B>TFTP Server IP Address </B></TD><TD>"
echo "<INPUT TYPE=TEXT NAME=tftpIp VALUE=\"10.10.10.11\"><BR>"
echo "</TD></TR>";
echo "<TR><TD VALIGN=top><B>Enable Complex Scale Vector Configuration File </B><BR></TD><TD VALIGN=top>"

echo "<NOBR><INPUT TYPE=RADIO NAME=enableCsv VALUE=\"1\" CHECKED> enabled</NOBR><BR>"
echo "<NOBR><INPUT TYPE=RADIO NAME=enableCsv VALUE=\"0\"> disabled</NOBR><BR>"
echo "</TD></TR>";



echo "<TR></TR></TABLE>";
echo "<INPUT TYPE=submit VALUE=\"Accept Changes\" >"
echo "<INPUT TYPE=reset VALUE=\"Clear Changes\" >"
echo "</FORM>"
echo "<P><B>Note:</B> <BR> Submitting configuration changes will suspend exgine operation until the system is restarted.<P>";
echo "</BODY>"
echo "</HTML>"

















