#!/bin/sh
echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>Edit E2X Transport Mode</TITLE><BODY>";
cd /mnt/flash

errMsg="<BR>Please use your browser's <B>back</B> button to correct the error.<BR>";

#
# Read CGI data
#
read data_in

# current gateway setting
gateway=`route | sed -n "s/.*default *\([0-9.]*\).*/\1/p"`
if [ "X$gateway" = "X" ]; then
    gateway="0.0.0.0"
fi

#
# Parse the input data
#
if [ "X$data_in" != "X" ]; then
	#
	# Input checking
	#
	#echo "Got $data_in"
	newGateway=`echo $data_in | sed -n "s/.*\(newGateway=\)\([^\&]*\).*/\2/p"`
	
	
	# check IP addresse
    i=1;
    while [ $i -lt 5 ]; do
		byte=`echo $newGateway | sed -n 's/^\([0-9]*\).\([0-9]*\).\([0-9]*\).\([0-9]*\)$/\'$i'/p'`;
		if [ "X$byte" = "X" ]; then
			echo "Gateway misconfiguration ($newGateway)<BR>$errMsg";
			exit;
		fi
		if [ $byte -gt 255 ]; then
			echo "Gateway misconfiguration ($newGateway)<BR>$errMsg";
			exit;
		fi
		
		let i=i+1;
	done
    

    if [ "X$gateway" != "X0.0.0.0" ]; then
        #echo "Disabling default route";
        route del default
    fi
    if [ "X$newGateway" != "X0.0.0.0" ]; then

        # do a ping test
        result=`ping -c 1 $newGateway`;
        npkts=`echo $result | sed -n "s/.* \([0-9]*\) packets received.*/\1/p"`
        #echo "Got $npkts ping returns ($newGateway) ($result)";
        if [ "X$npkts" = "X" ]; then
            echo "Could not ping $newGateway, new gateway not set. <BR>$errMsg";
            exit;
        fi
        if [ $npkts -lt 1 ]; then
            echo "Could not ping $newGateway, new gateway not set. <BR>$errMsg";
            exit;
        fi
        
        route add default gw $newGateway
        
    fi
    
	
fi

#
# Read configuration file settings
#

# current gateway setting
gateway=`route | sed -n "s/.*default *\([0-9.]*\).*/\1/p"`
if [ "X$gateway" = "X" ]; then
    gateway="0.0.0.0"
fi



#
# Build the HTML page
#
echo "<FORM METHOD=POST ACTION=dyngateway.sh>"

echo "<TABLE WIDTH=80% CELLSPACING=0 CELLPADDING=4>"
echo "<TR><TD bgcolor=\"#09254a\" COLSPAN=2><FONT color=gray FACE=\"Verdana\"><NOBR><B>Dynamic Gateway Reassignment</NOBR></B></FONT></TD>";
echo "<TD ALIGN=right bgcolor=\"#09254a\"></TD></TR>";
echo "<TR><TD COLSPAN=2><P><B>Note:</B><BR>"
echo "This setting only temporarily configures the default gateway for the current E2X connection.  In order to"
echo "configure a permanent gateway change, use the <A HREF="netcfg.sh">Network Configuration Screen</A>."
echo "<P>"
echo "If your STLs are protected by L3 routers, you can use this setting to dynamically switch your"
echo "HD traffic to an alternate STL for the duration of this E2X connection.  This setting can be"
echo "dynamically switched back to its original setting."
echo "<P>"
echo "Configuring a gateway of 0.0.0.0 removes the default route."
echo "<P></B></TD><TD>"

echo "<TR><TD><B>New Default Gateway:</B></TD><TD><INPUT TYPE=text NAME=newGateway VALUE=\"$gateway\"></TD></TR>";

echo "<TR></TR></TABLE><P>";
echo "<INPUT TYPE=submit VALUE=\"Accept Changes\" >"
echo "<INPUT TYPE=reset VALUE=\"Clear Changes\" >"
echo "</FORM>"
echo "</BODY>"

















