#!/bin/sh
echo "Content-type: text/html";
echo;
echo "<HTML><TITLE>Edit E2X Transport Mode</TITLE><BODY>";
cd /mnt/flash

errMsg="<BR>Please use your browser's <B>back</B> button to correct the error.<BR>";

#
# Read CGI data
#
read data_in

#
# Parse the input data
#
if [ "X$data_in" != "X" ]; then
	#
	# Input checking
	#
	#echo "Got $data_in"
	newE2xTransportMode=`echo $data_in | sed -n "s/.*\(newE2xTransportMode=\)\([^\&]*\).*/\2/p"`
	newEnableTimingRecovery=`echo $data_in | sed -n "s/.*\(newEnableTimingRecovery=\)\([^\&]*\).*/\2/p"`
	newHdpTxIp=`echo $data_in | sed -n "s/.*\(newHdpTxIp=\)\([^\&]*\).*/\2/p"`
	newHdpTxPort=`echo $data_in | sed -n "s/.*\(newHdpTxPort=\)\([^\&]*\).*/\2/p"`
	newTransportProtocol=`echo $data_in | sed -n "s/.*\(newTransportProtocol=\)\([^\&]*\).*/\2/p"`
	newPacketBufferDepth=`echo $data_in | sed -n "s/.*\(newPacketBufferDepth=\)\([^\&]*\).*/\2/p"`
	newCtrlPktInsertionRate=`echo $data_in | sed -n "s/.*\(newCtrlPktInsertionRate=\)\([^\&]*\).*/\2/p"`
	newMaxBandwidth=`echo $data_in | sed -n "s/.*\(newMaxBandwidth=\)\([^\&]*\).*/\2/p"`
	newMainBandwidth=`echo $data_in | sed -n "s/.*\(newMainBandwidth=\)\([^\&]*\).*/\2/p"`
	newCtrlPlaneMasterPort=`echo $data_in | sed -n "s/.*\(newCtrlPlaneMasterPort=\)\([^\&]*\).*/\2/p"`
	newCtrlPlaneSlavePort=`echo $data_in | sed -n "s/.*\(newCtrlPlaneSlavePort=\)\([^\&]*\).*/\2/p"`
	newDataPlanePort=`echo $data_in | sed -n "s/.*\(newDataPlanePort=\)\([^\&]*\).*/\2/p"`
	newE2xTosField=`echo $data_in | sed -n "s/.*\(newE2xTosField=\)\([^\&]*\).*/\2/p"`
	newEnableHpTraffic=`echo $data_in | sed -n "s/.*\(newEnableHpTraffic=\)\([^\&]*\).*/\2/p"`
	newE2xTosFieldHp=`echo $data_in | sed -n "s/.*\(newE2xTosFieldHp=\)\([^\&]*\).*/\2/p"`
	newInsertClockPackets=`echo $data_in | sed -n "s/.*\(newInsertClockPackets=\)\([^\&]*\).*/\2/p"`
	
	
	if [ "$newE2xTransportMode" != "enabled" ]; then
		newE2xTransportMode="disabled";
	fi

	if [ "$newInsertClockPackets" != "disabled" ]; then
		newInsertClockPackets="enabled";
	fi

	if [ "$newEnableTimingRecovery" != "enabled" ]; then
		newEnableTimingRecovery="disabled";
	fi

	
	# check IP addresses
    i=1;
    while [ $i -lt 5 ]; do
		byte=`echo $newHdpTxIp | sed -n 's/^\([0-9]*\).\([0-9]*\).\([0-9]*\).\([0-9]*\)$/\'$i'/p'`;
		if [ "X$byte" = "X" ]; then
			echo "Exgine IP address misconfiguration ($newHdpTxIp)<BR>$errMsg";
			exit;
		fi
		if [ $byte -gt 255 ]; then
			echo "Exgine IP address misconfiguration ($newHdpTxIp)<BR>$errMsg";
			exit;
		fi
		
		let i=i+1;
	done

	val=`echo $newHdpTxPort | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid HDP TX Port ($newHdpTxPort)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 65535 ]; then
		echo "Invalid HDP TX Port ($newHdpTxPort)<BR>$errMsg";
		exit;
	fi


	
	val=`echo $newTransportProtocol | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid transport protocol ($newTransportProtocol)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 2 ]; then
		echo "Invalid transport protocol ($newTransportProtocol)<BR>$errMsg";
		exit;
	fi
	
	val=`echo $newPacketBufferDepth | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid receive buffer depth ($newPacketBufferDepth)<BR>$errMsg";
		exit;
	fi
	if [ $val -lt 1 ]; then
		echo "Require buffer depth > 0 ($newPacketBufferDepth)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 99 ]; then
		echo "Require buffer depth < 100 ($newPacketBufferDepth)<BR>$errMsg";
		exit;
	fi

	val=`echo $newCtrlPktInsertionRate | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid packet insertion rate ($newCtrlPktInsertionRate)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 99 ]; then
		echo "Invalid packet insertion rate must be 100 ($newCtrlPktInsertionRate)<BR>$errMsg";
		exit;
	fi

	val=`echo $newMaxBandwidth | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid total bandwidth ($newMaxBandwidth)<BR>$errMsg";
		exit;
	fi
	if [ $val -lt 100000 ]; then
		echo "Invalid total bandwidth > 100000 bps ($newMaxBandwidth)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 10000000 ]; then
		echo "Invalid total bandwidth < 10 Mbps ($newMaxBandwidth)<BR>$errMsg";
		exit;
	fi
	
	
	
	val=`echo $newMainBandwidth | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid main bandwidth ($newMainBandwidth)<BR>$errMsg";
		exit;
	fi
	if [ $val -lt 100000 ]; then
		echo "Invalid main bandwidth > 100000 bps ($newMainBandwidth)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 10000000 ]; then
		echo "Invalid main bandwidth < 10 Mbps ($newMainBandwidth)<BR>$errMsg";
		exit;
	fi
	if [ $newMainBandwidth -gt $newMaxBandwidth ]; then
		echo "main bandwidth must be less than total bandiwdth (main: $newMainBandwidth, total $newMaxBandwidth)<BR>$errMsg";
		exit;
	fi
	

	val=`echo $newCtrlPlaneMasterPort | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid ctrl plane master port ($newCtrlPlaneMasterPort)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 65535 ]; then
		echo "Invalid ctrl plane master port ($newCtrlPlaneMasterPort)<BR>$errMsg";
		exit;
	fi

	val=`echo $newCtrlPlaneSlavePort | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid ctrl plane slave port ($newCtrlPlaneSlavePort)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 65535 ]; then
		echo "Invalid ctrl plane slave port ($newCtrlPlaneSlavePort)<BR>$errMsg";
		exit;
	fi

	val=`echo $newDataPlanePort | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid data port ($newDataPlanePort)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 65535 ]; then
		echo "Invalid data port ($newDataPlanePort)<BR>$errMsg";
		exit;
	fi
	

	val=`echo $newE2xTosField | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid TOS field ($newE2xTosField)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 255 ]; then
		echo "Invalid TOS field ($newE2xTosField)<BR>$errMsg";
		exit;
	fi

	val=`echo $newE2xTosFieldHp | sed -n 's/^\([0-9]*\)$/\1/p'`;
	if [ "X$val" = "X" ]; then
		echo "Invalid clock TOS field ($newE2xTosFieldHp)<BR>$errMsg";
		exit;
	fi
	if [ $val -gt 255 ]; then
		echo "Invalid clock TOS field ($newE2xTosFieldHp)<BR>$errMsg";
		exit;
	fi

	if [ "$newEnableHpTraffic" != "enabled" ]; then
		newEnableHpTraffic="disabled";
	fi

	#echo "<BR>"
	#echo "newTransportProtocol	  $newTransportProtocol	<BR>"
	#echo "newPacketBufferDepth    $newPacketBufferDepth	<BR>"
	#echo "newCtrlPktInsertionRate $newCtrlPktInsertionRate<BR>"
	#echo "newMaxBandwidth         $newMaxBandwidth		<BR>"
	#echo "newMainBandwidth        $newMainBandwidth		<BR>"
	#echo "newCtrlPlaneMasterPort  $newCtrlPlaneMasterPort	<BR>"
	#echo "newCtrlPlaneSlavePort   $newCtrlPlaneSlavePort	<BR>"
	#echo "newDataPlanePort        $newDataPlanePort		<BR>"
	#echo "newE2xTosField          $newE2xTosField			<BR>"
	#echo "newEnableHpTraffic      $newEnableHpTraffic		<BR>"
	#echo "newE2xTosFieldHp        $newE2xTosFieldHp       <BR>"
	
	#
	# Update configuration files
	#
	
	cp -f /mnt/flash/exgine.cfg /tmp/exgine2.cfg
	sed -e	"s/\(e2xTransportMode:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newE2xTransportMode\2/" /tmp/exgine2.cfg > /tmp/exgine3.cfg
	sed -e	"s/\(enableTimingRecovery:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newEnableTimingRecovery\2/" /tmp/exgine3.cfg > /tmp/exgine.cfg
    
	cp -f /mnt/flash/e2x.cfg /tmp/e2x.cfg
	sed -e	"s/\(transportProtocol:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newTransportProtocol\2/" /tmp/e2x.cfg > /tmp/e2x2.cfg
	sed -e	"s/\(packetBufferDepth:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newPacketBufferDepth\2/" /tmp/e2x2.cfg > /tmp/e2x.cfg
	sed -e	"s/\(ctrlPktInsertionRate:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newCtrlPktInsertionRate\2/" /tmp/e2x.cfg > /tmp/e2x2.cfg
	sed -e	"s/\(maxBandwidth:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newMaxBandwidth\2/" /tmp/e2x2.cfg > /tmp/e2x.cfg
	sed -e	"s/\(mainBandwidth:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newMainBandwidth\2/" /tmp/e2x.cfg > /tmp/e2x2.cfg
	sed -e	"s/\(ctrlPlaneMasterPort:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newCtrlPlaneMasterPort\2/" /tmp/e2x2.cfg > /tmp/e2x.cfg
	sed -e	"s/\(ctrlPlaneSlavePort:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newCtrlPlaneSlavePort\2/" /tmp/e2x.cfg > /tmp/e2x2.cfg
	sed -e	"s/\(dataPlanePort:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newDataPlanePort\2/" /tmp/e2x2.cfg > /tmp/e2x.cfg
	sed -e	"s/\(e2xTosField:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newE2xTosField\2/" /tmp/e2x.cfg > /tmp/e2x2.cfg
	sed -e	"s/\(enableHpTraffic:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newEnableHpTraffic\2/" /tmp/e2x2.cfg > /tmp/e2x.cfg
	sed -e	"s/\(hdpTxIp:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newHdpTxIp\2/" /tmp/e2x.cfg > /tmp/e2x2.cfg
    sed -e	"s/\(hdpTxPort:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newHdpTxPort\2/" /tmp/e2x2.cfg > /tmp/e2x.cfg
	sed -e	"s/\(e2xTosFieldHp:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newE2xTosFieldHp\2/" /tmp/e2x.cfg > /tmp/e2x2.cfg
	sed -e	"s/\(insertClockPackets:[ \t]*\)[^ \t\#]*\(.*$\)/\1$newInsertClockPackets\2/" /tmp/e2x2.cfg > /tmp/e2x.cfg
	
	cat /proc/flash_write_enable > /dev/null
	mount -o remount,rw /mnt/flash
	
	if [ -e /mnt/flash/exgine.cfg ] ; then 
    		cp -f /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
	fi
	cp -f /tmp/exgine.cfg /mnt/flash/exgine.cfg
	
	if [ -e /mnt/flash/e2x.cfg ] ; then 
    		cp -f /mnt/flash/e2x.cfg /mnt/flash/e2x.cfg.bkup
	fi
	cp -f /tmp/e2x.cfg /mnt/flash/e2x.cfg
	
	mount -o remount,ro /mnt/flash
	cat /proc/flash_write_disable > /dev/null
	echo "<P><B>Note:</B> Changes have been applied.  A <A HREF="reboot.sh">reboot</A> is required for these changes to take effect.<P>";
fi

#
# Read configuration file settings
#

# exgine IP address
e2xTransportMode=`sed -n "s/\(e2xTransportMode:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
enableTimingRecovery=`sed -n "s/\(enableTimingRecovery:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/exgine.cfg`;
hdpTxIp=`sed -n "s/\(hdpTxIp:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
packetBufferDepth=`sed -n "s/\(packetBufferDepth:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
ctrlPktInsertionRate=`sed -n "s/\(ctrlPktInsertionRate:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
maxBandwidth=`sed -n "s/\(maxBandwidth:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
mainBandwidth=`sed -n "s/\(mainBandwidth:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
ctrlPlaneMasterPort=`sed -n "s/\(ctrlPlaneMasterPort:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
ctrlPlaneSlavePort=`sed -n "s/\(ctrlPlaneSlavePort:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
dataPlanePort=`sed -n "s/\(dataPlanePort:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
e2xTosField=`sed -n "s/\(e2xTosField:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
enableHpTraffic=`sed -n "s/\(enableHpTraffic:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
e2xTosFieldHp=`sed -n "s/\(e2xTosFieldHp:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
transportProtocol=`sed -n "s/\(transportProtocol:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
hdpTxPort=`sed -n "s/\(hdpTxPort:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;
insertClockPackets=`sed -n "s/\(insertClockPackets:[ \t]*\)\([^ \t\#]*\)\(.*$\)/\2/p" /mnt/flash/e2x.cfg`;

#
# Build the HTML page
#
echo "<FORM METHOD=POST ACTION=e2xtransport.sh>"

echo "<TABLE WIDTH=80% CELLSPACING=0  CELLPADDING=4>"
echo "<TR><TD bgcolor=\"#09254a\"><FONT color=gray FACE=\"Verdana\"><B>E2X Transport Configuration</B></FONT></TD>";
echo "<TD ALIGN=right bgcolor=\"#09254a\"><A HREF=\"/e2xtransport_hlp.html\" TRAGET=_blank><FONT color=gray FACE=\"Verdana\"><B>[help]</b></FONT></A></TD></TR>";
echo "<TR><TD VALIGN=top><B>Operating mode </B></TD><TD>"

if [ "$e2xTransportMode" = "enabled" ]; then
	default_exgine="";
	default_transport="CHECKED";
else
	default_exgine="CHECKED";
	default_transport="";
fi

echo "<INPUT TYPE=RADIO NAME=newE2xTransportMode VALUE=\"disabled\" $default_exgine> Exgine mode<BR>"
echo "<INPUT TYPE=RADIO NAME=newE2xTransportMode VALUE=\"enabled\" $default_transport> E2X Transport mode"
echo "</TD></TR>";


echo "<TR><TD VALIGN=top><B>E2X Transport Protocol </B></TD><TD>"

if [ "$transportProtocol" = "0" ]; then
	defaultudp="CHECKED"
	defaulttcp=""
	defaultencap=""
elif [ "$transportProtocol" = "1" ]; then
	defaultudp=""
	defaulttcp="CHECKED"
	defaultencap=""
else
	defaultudp=""
	defaulttcp=""
	defaultencap="CHECKED"
fi

echo "<INPUT TYPE=RADIO NAME=newTransportProtocol VALUE=\"0\" $defaultudp> UDP (unidirectional)<BR>"
echo "<INPUT TYPE=RADIO NAME=newTransportProtocol VALUE=\"1\" $defaulttcp> TCP (bidirectional)<BR>"
echo "<INPUT TYPE=RADIO NAME=newTransportProtocol VALUE=\"2\" $defaultencap> Nautel Reliable HD Transport<BR>"
echo "</TD></TR>";


#newExgineIp
#exgineMacMsb
#exgineMacLsb
#transportProtocol
#packetBufferDepth
#ctrlPktInsertionRate
#maxBandwidth
#mainBandwidth
#ctrlPlaneMasterPort
#ctrlPlaneSlavePort
#dataPlanePort
#e2xTosField
#enableHpTraffic
#e2xTosFieldHp

echo "<TR><TD VALIGN=top><B>Enable Timing Recovery</B></TD><TD>"
if [ "$enableTimingRecovery" = "enabled" ]; then
	default_tr_yes="CHECKED";
	default_tr_no="";
else
	default_tr_yes="";
	default_tr_no="CHECKED";
fi

echo "<INPUT TYPE=RADIO NAME=newEnableTimingRecovery VALUE=\"enabled\" $default_tr_yes> yes"
echo "<INPUT TYPE=RADIO NAME=newEnableTimingRecovery VALUE=\"disabled\" $default_tr_no> no"
echo "</TD></TR>";



echo "<TR><TD><B>Transmit Buffer Depth</B></TD><TD><INPUT TYPE=text NAME=newPacketBufferDepth VALUE=\"$packetBufferDepth\"></TD></TR>";

echo "<TR><TD><B>HDP TX IP (UDP/TCP)</B></TD><TD><INPUT TYPE=text NAME=newHdpTxIp VALUE=\"$hdpTxIp\"></TD></TR>";
echo "<TR><TD><B>HDP TX Port (UDP/TCP)</B></TD><TD><INPUT TYPE=text NAME=newHdpTxPort VALUE=\"$hdpTxPort\"></TD></TR>";
echo "<TR><TD VALIGN=top><B>Reliable HD Transport TX</B></TD><TD><A HREF=\"municast.sh\">configure multiple unicast</A> <BR>(unsubmitted changes on this page will be lost)</TD></TR>";
echo "<TR><TD><B>Control Packet Rate</B></TD><TD><INPUT TYPE=text NAME=newCtrlPktInsertionRate VALUE=\"$ctrlPktInsertionRate\"></TD></TR>";
echo "<TR><TD><B>Main Bandwidth</B></TD><TD><INPUT TYPE=text NAME=newMainBandwidth VALUE=\"$mainBandwidth\"></TD></TR>";
echo "<TR><TD><B>Total Bandwidth</B></TD><TD><INPUT TYPE=text NAME=newMaxBandwidth VALUE=\"$maxBandwidth\"></TD></TR>";
echo "<TR><TD><B>Data Plane Port</B></TD><TD><INPUT TYPE=text NAME=newDataPlanePort VALUE=\"$dataPlanePort\"></TD></TR>";
echo "<TR><TD><B>Control Plane Master Port</B></TD><TD><INPUT TYPE=text NAME=newCtrlPlaneMasterPort VALUE=\"$ctrlPlaneMasterPort\"></TD></TR>";
echo "<TR><TD><B>Control Plane Slave Port</B></TD><TD><INPUT TYPE=text NAME=newCtrlPlaneSlavePort VALUE=\"$ctrlPlaneSlavePort\"></TD></TR>";
echo "<TR><TD><B>IP TOS field (decimal)</B></TD><TD><INPUT TYPE=text NAME=newE2xTosField VALUE=\"$e2xTosField\"></TD></TR>";


echo "<TR><TD><B>Different TOS for clock packets</B></TD><TD>"

if [ "$enableHpTraffic" = "enabled" ]; then
	defaultyes="CHECKED";
	defaultno="";
else
	defaultyes="";
	defaultno="CHECKED";
fi

echo "<INPUT TYPE=RADIO NAME=newEnableHpTraffic VALUE=\"enabled\" $defaultyes> yes"
echo "<INPUT TYPE=RADIO NAME=newEnableHpTraffic VALUE=\"disabled\" $defaultno> no"
echo "</TD></TR>";

echo "<TR><TD><B>Clock TOS field (decimal)</B></TD><TD><INPUT TYPE=text NAME=newE2xTosFieldHp VALUE=\"$e2xTosFieldHp\"></TD></TR>";


echo "<TR><TD><B>Insert missing clock packets</B></TD><TD>"

if [ "$insertClockPackets" = "enabled" ]; then
	defaultyes="CHECKED";
	defaultno="";
else
	defaultyes="";
	defaultno="CHECKED";
fi

echo "<INPUT TYPE=RADIO NAME=newInsertClockPackets VALUE=\"enabled\" $defaultyes> yes"
echo "<INPUT TYPE=RADIO NAME=newInsertClockPackets VALUE=\"disabled\" $defaultno> no"
echo "</TD></TR>";

echo "<TR></TR></TABLE>";
echo "<INPUT TYPE=submit VALUE=\"Accept Changes\" >"
echo "<INPUT TYPE=reset VALUE=\"Clear Changes\" >"
echo "</FORM>"
echo "</BODY>"

















