#!/bin/sh
if [ "X$1" = "X" ] ; then
    echo "Usage: install.sh [ip address]"
    exit;
fi
echo "Starting install script ..."

echo "This process will install EXGINE Version 2.4"

# exits existing exgine server gracefully
killall -2 exgined
sleep 1

cat /proc/flash_write_enable
mount -o remount,rw /mnt/flash

echo Updating EXGINE software ...
HOST=$1
FILES="dsp_lkm.o fpga_lkm.o gpio_lkm.o fp_lkm.o fp_new_protocol_lkm.o exgined user_if eex_am.m0 eex_fm.m0 \
      init.sh setdefault.sh update.sh exgine.cfg exgine.fdcfg e2x.cfg e2x.fdcfg httpd.conf www/index.html www/countdown.js \
      www/nautel_logo.jpg www/cgi-bin/reboot.sh www/cgi-bin/fwupload.sh www/cgi-bin/municast.sh \
	  www/cgi-bin/osupload.sh www/cgi-bin/editcfg.sh www/cgi-bin/cfgupload.sh \
      www/cgi-bin/editcal.sh www/maintenance.html www/netcfg_hlp.html www/e2xtransport_hlp.html\
	  www/configuration.html www/cgi-bin/netcfg.sh www/cgi-bin/platformcfg.sh www/cgi-bin/e2xtransport.sh www/cgi-bin/dyngateway.sh\
      www/cgi-bin/amexgine.sh www/cgi-bin/fmexgine.sh www/amexgine_hlp.html www/cgi-bin/csvupload.sh www/csv_hlp.html\
      www/cgi-bin/mpsextract.sh www/fmexgine_hlp.html www/mpsextract_hlp.html www/cgi-bin/webpassword.sh"	
      
echo   Downloading compressed files from $HOST ...
cd /tmp/
rm -rf exgine
install -d www
install -d www/cgi-bin

FILE="exgine_v2_4.tar.gz"
echo "  Fetching $FILE ...";
tftp -g -r $FILE $HOST
# get file size
SIZE=`ls -s $FILE`;
for S in $SIZE
do
	if [ $S = "0" ]; then
		echo "$FILE did not transfer (0 bytes) ... aborting."
		exit
	fi
done

echo "Extracting files ..."
tar -zxf $FILE
cd exgine

echo "File integrity check ..."
for FILE in $FILES
do
	
	if [ -f $FILE ]
	then
		echo "  Checking $FILE ... ";
	else
		echo "  $FILE does not exist ... aborting.";
		exit
	fi

	# get file size
	SIZE=`ls -s $FILE`;
	for S in $SIZE
	do
		
		if [ $S = "0" ]; then
			echo "$FILE did not transfer correctly (0 bytes) ... aborting."
			exit
		fi
	done
done


echo   "Copying files to FLASH ..."

install -d /mnt/flash/www
install -d /mnt/flash/www/cgi-bin
if [ -e /mnt/flash/exgine.cfg ] ; then 
    cp /mnt/flash/exgine.cfg /mnt/flash/exgine.cfg.bkup
fi

#cd /tmp/exgine
#chmod a+x exgined
#chmod a+x user_if
#chmod a+x init.sh
#chmod a+x setdefault.sh
#chmod a+x update.sh


for FILE in $FILES
do
	echo "  Installing $FILE ...";
	cp -f $FILE /mnt/flash/$FILE
done
chmod a+x /mnt/flash/www/cgi-bin/*
cd /mnt/flash
chmod a+x exgined
chmod a+x user_if
chmod a+x init.sh
chmod a+x setdefault.sh
chmod a+x update.sh
sync
mount -o remount,ro /mnt/flash
cat /proc/flash_write_disable

echo Refreshing web interface ...
if [ -e /mnt/flash/www ]; then
    install -d /tmp/www
    cp -af /mnt/flash/www/* /tmp/www
	chmod a+x /tmp/www/cgi-bin/*
# can't kill, in case we are doing upgrade from web interface
# assume HTTP is 
#    killall httpd
#   httpd -p 80 -h /tmp/www
fi


echo Update complete.
